<?php

namespace FiloBlu\EvaAttributes\Helper;

class AttributeHelper {

    /**
     * @var AttributeArray
     */
    protected $attributeArray;

    /**
     * AttributeHelper constructor.
     * @param \FiloBlu\EvaAttributes\Model\AttributeArray $attributeArray
     */
    public function __construct(
        \FiloBlu\EvaAttributes\Model\AttributeArray $attributeArray
    )
    {
        $this->attributeArray = $attributeArray;
    }

    /**
     * @param \Magento\Eav\Setup\EavSetup $eavSetup
     * @param $attribute
     */
    protected function createAttribute(
        \Magento\Eav\Setup\EavSetup $eavSetup,
        $attribute
    ) {

        if($eavSetup->getAttribute($attribute->getEntityTypeId(),$attribute->getAttributeCode(),'attribute_code') === false){
            print_r($attribute);
            echo "------------> creating ".$attribute->getAttributeCode()."\n";
            $eavSetup->addAttribute(
                $attribute->getEntityTypeId(),
                $attribute->getAttributeCode(),
                $attribute->getData()
            );
        }

    }

    /**
     * @param \Magento\Eav\Setup\EavSetup $eavSetup
     */
    public function installAttributes(
        \Magento\Eav\Setup\EavSetup $eavSetup
    ) {

        foreach ($this->attributeArray as $attribute) {
            $this->createAttribute($eavSetup, $attribute);
        }

    }

}

