# Eva Attributes
Base attribute creator for Magento 2

## Installation
```sh
composer require filoblu/mod2-eva-attributes
```

## Usage
With Eva Attributes you can create attributes in Magento automatically through setup:upgrade

### Base attributes boilerplate
There are several base attribute boilerplate with overridable default values: Text, Text Area, Select, Multiselect, Boolean
```xml
<!-- BASE SELECT ATTRIBUTE -->
<virtualType name="FiloBlu\EvaAttributes\BaseSelect" type="FiloBlu\EvaAttributes\Model\BaseAttribute" shared="false">
    <arguments>
        <argument name="data" xsi:type="array">
            <item name="type" xsi:type="string">int</item>
            <item name="label" xsi:type="string">-- Select Label --</item>
            <item name="input" xsi:type="string">select</item>
            <item name="class" xsi:type="string"></item>
            <item name="backend" xsi:type="string"></item>
            <item name="frontend" xsi:type="string"></item>
            <item name="source" xsi:type="string"></item>
            <item name="visible" xsi:type="boolean">true</item>
            <item name="visible_on_front" xsi:type="boolean">false</item>
            <item name="searchable" xsi:type="boolean">false</item>
            <item name="filterable" xsi:type="boolean">false</item>
            <item name="comparable" xsi:type="boolean">false</item>
            <item name="unique" xsi:type="boolean">false</item>
            <item name="apply_to" xsi:type="string"></item>
            <item name="used_in_product_listing" xsi:type="boolean">false</item>
            <item name="user_defined" xsi:type="boolean">true</item>
            <item name="required" xsi:type="boolean">false</item>
            <item name="global" xsi:type="const">Magento\Eav\Model\Entity\Attribute\ScopedAttributeInterface::SCOPE_GLOBAL</item>
            <item name="is_used_in_grid" xsi:type="boolean">false</item>
            <item name="is_visible_in_grid" xsi:type="boolean">false</item>
            <item name="is_filterable_in_grid" xsi:type="boolean">false</item>
        </argument>
    </arguments>
</virtualType>
<!-- BASE SELECT ATTRIBUTE -->

<!-- BASE TEXT ATTRIBUTE -->
<virtualType name="FiloBlu\EvaAttributes\BaseText" type="FiloBlu\EvaAttributes\Model\BaseAttribute" shared="false">
    <arguments>
        <argument name="data" xsi:type="array">
            <item name="type" xsi:type="string">varchar</item>
            <item name="label" xsi:type="string">-- Select Label --</item>
            <item name="input" xsi:type="string">text</item>
            <item name="class" xsi:type="string"></item>
            <item name="backend" xsi:type="string"></item>
            <item name="frontend" xsi:type="string"></item>
            <item name="source" xsi:type="string"></item>
            <item name="visible" xsi:type="boolean">true</item>
            <item name="visible_on_front" xsi:type="boolean">false</item>
            <item name="searchable" xsi:type="boolean">false</item>
            <item name="filterable" xsi:type="boolean">false</item>
            <item name="comparable" xsi:type="boolean">false</item>
            <item name="unique" xsi:type="boolean">false</item>
            <item name="apply_to" xsi:type="string"></item>
            <item name="used_in_product_listing" xsi:type="boolean">false</item>
            <item name="user_defined" xsi:type="boolean">true</item>
            <item name="required" xsi:type="boolean">false</item>
            <item name="global" xsi:type="const">Magento\Eav\Model\Entity\Attribute\ScopedAttributeInterface::SCOPE_GLOBAL</item>
            <item name="is_used_in_grid" xsi:type="boolean">false</item>
            <item name="is_visible_in_grid" xsi:type="boolean">false</item>
            <item name="is_filterable_in_grid" xsi:type="boolean">false</item>
        </argument>
    </arguments>
</virtualType>
<!-- BASE TEXT ATTRIBUTE -->

<!-- BASE TEXTAREA ATTRIBUTE -->
<virtualType name="FiloBlu\EvaAttributes\BaseTextarea" type="FiloBlu\EvaAttributes\Model\BaseAttribute" shared="false">
    <arguments>
        <argument name="data" xsi:type="array">
            <item name="type" xsi:type="string">varchar</item>
            <item name="label" xsi:type="string">-- Select Label --</item>
            <item name="input" xsi:type="string">textarea</item>
            <item name="class" xsi:type="string"></item>
            <item name="backend" xsi:type="string"></item>
            <item name="frontend" xsi:type="string"></item>
            <item name="source" xsi:type="string"></item>
            <item name="visible" xsi:type="boolean">true</item>
            <item name="visible_on_front" xsi:type="boolean">false</item>
            <item name="searchable" xsi:type="boolean">false</item>
            <item name="filterable" xsi:type="boolean">false</item>
            <item name="comparable" xsi:type="boolean">false</item>
            <item name="unique" xsi:type="boolean">false</item>
            <item name="apply_to" xsi:type="string"></item>
            <item name="used_in_product_listing" xsi:type="boolean">false</item>
            <item name="user_defined" xsi:type="boolean">true</item>
            <item name="required" xsi:type="boolean">false</item>
            <item name="global" xsi:type="const">Magento\Eav\Model\Entity\Attribute\ScopedAttributeInterface::SCOPE_GLOBAL</item>
            <item name="is_used_in_grid" xsi:type="boolean">false</item>
            <item name="is_visible_in_grid" xsi:type="boolean">false</item>
            <item name="is_filterable_in_grid" xsi:type="boolean">false</item>
        </argument>
    </arguments>
</virtualType>
<!-- BASE TEXTAREA ATTRIBUTE -->

<!-- BASE BOOLEAN ATTRIBUTE -->
<virtualType name="FiloBlu\EvaAttributes\BaseBoolean" type="FiloBlu\EvaAttributes\Model\BaseAttribute" shared="false">
    <arguments>
        <argument name="data" xsi:type="array">
            <item name="type" xsi:type="string">int</item>
            <item name="label" xsi:type="string">-- Select Label --</item>
            <item name="input" xsi:type="string">boolean</item>
            <item name="class" xsi:type="string"></item>
            <item name="backend" xsi:type="string"></item>
            <item name="frontend" xsi:type="string"></item>
            <item name="source" xsi:type="string"></item>
            <item name="visible" xsi:type="boolean">true</item>
            <item name="visible_on_front" xsi:type="boolean">false</item>
            <item name="searchable" xsi:type="boolean">false</item>
            <item name="filterable" xsi:type="boolean">false</item>
            <item name="comparable" xsi:type="boolean">false</item>
            <item name="unique" xsi:type="boolean">false</item>
            <item name="apply_to" xsi:type="string"></item>
            <item name="used_in_product_listing" xsi:type="boolean">false</item>
            <item name="user_defined" xsi:type="boolean">true</item>
            <item name="required" xsi:type="boolean">false</item>
            <item name="global" xsi:type="const">Magento\Eav\Model\Entity\Attribute\ScopedAttributeInterface::SCOPE_GLOBAL</item>
            <item name="is_used_in_grid" xsi:type="boolean">false</item>
            <item name="is_visible_in_grid" xsi:type="boolean">false</item>
            <item name="is_filterable_in_grid" xsi:type="boolean">false</item>
        </argument>
    </arguments>
</virtualType>
<!-- BASE BOOLEAN ATTRIBUTE -->

<!-- BASE MULTISELECT ATTRIBUTE -->
<virtualType name="FiloBlu\EvaAttributes\BaseMultiselect" type="FiloBlu\EvaAttributes\Model\BaseAttribute" shared="false">
    <arguments>
        <argument name="data" xsi:type="array">
            <item name="type" xsi:type="string">varchar</item>
            <item name="label" xsi:type="string">-- Select Label --</item>
            <item name="input" xsi:type="string">multiselect</item>
            <item name="class" xsi:type="string"></item>
            <item name="backend" xsi:type="string">Magento\Eav\Model\Entity\Attribute\Backend\ArrayBackend</item>
            <item name="frontend" xsi:type="string"></item>
            <item name="source" xsi:type="string"></item>
            <item name="visible" xsi:type="boolean">true</item>
            <item name="visible_on_front" xsi:type="boolean">false</item>
            <item name="searchable" xsi:type="boolean">false</item>
            <item name="filterable" xsi:type="boolean">false</item>
            <item name="comparable" xsi:type="boolean">false</item>
            <item name="unique" xsi:type="boolean">false</item>
            <item name="apply_to" xsi:type="string"></item>
            <item name="used_in_product_listing" xsi:type="boolean">false</item>
            <item name="user_defined" xsi:type="boolean">true</item>
            <item name="required" xsi:type="boolean">false</item>
            <item name="global" xsi:type="const">Magento\Eav\Model\Entity\Attribute\ScopedAttributeInterface::SCOPE_GLOBAL</item>
            <item name="is_used_in_grid" xsi:type="boolean">false</item>
            <item name="is_visible_in_grid" xsi:type="boolean">false</item>
            <item name="is_filterable_in_grid" xsi:type="boolean">false</item>
        </argument>
    </arguments>
</virtualType>
<!-- BASE MULTISELECT ATTRIBUTE -->
```

## Attributes examples
You can specify a new default attribute in di.xml in this way

#### TEXT ATTRIBUTE

```xml
<!-- Article Code -->
<virtualType name="FiloBlu\EvaAttributes\ArticleCode" type="FiloBlu\EvaAttributes\BaseText" shared="false">
    <arguments>
        <argument name="entityTypeId" xsi:type="const">Magento\Catalog\Model\Product::ENTITY</argument>
        <argument name="attributeCode" xsi:type="string">article_code</argument>
        <argument name="data" xsi:type="array">
            <item name="label" xsi:type="string">Article Code</item>
        </argument>
    </arguments>
</virtualType>
<!-- Article Code -->
```
#### TEXTAREA ATTRIBUTE

```xml
<!-- Details -->
<virtualType name="FiloBlu\EvaAttributes\Details" type="FiloBlu\EvaAttributes\BaseTextarea" shared="false">
    <arguments>
        <argument name="entityTypeId" xsi:type="const">Magento\Catalog\Model\Product::ENTITY</argument>
        <argument name="attributeCode" xsi:type="string">details</argument>
        <argument name="data" xsi:type="array">
            <item name="label" xsi:type="string">Details</item>
            <item name="global" xsi:type="const">Magento\Eav\Model\Entity\Attribute\ScopedAttributeInterface::SCOPE_STORE</item>
        </argument>
    </arguments>
</virtualType>
<!-- Details -->
```

#### SELECT ATTRIBUTE

```xml
<!-- Size -->
<virtualType name="FiloBlu\EvaAttributes\Size" type="FiloBlu\EvaAttributes\BaseSelect" shared="false">
    <arguments>
        <argument name="entityTypeId" xsi:type="const">Magento\Catalog\Model\Product::ENTITY</argument>
        <argument name="attributeCode" xsi:type="string">size</argument>
        <argument name="data" xsi:type="array">
            <item name="label" xsi:type="string">Size</item>
        </argument>
    </arguments>
</virtualType>
<!-- Size -->
```

#### MULTI SELECT ATTRIBUTE
```xml
<!-- Color Filter -->
<virtualType name="FiloBlu\EvaAttributes\ColorFilter" type="FiloBlu\EvaAttributes\BaseMultiselect" shared="false">
    <arguments>
        <argument name="entityTypeId" xsi:type="const">Magento\Catalog\Model\Product::ENTITY</argument>
        <argument name="attributeCode" xsi:type="string">color_filter</argument>
        <argument name="data" xsi:type="array">
            <item name="label" xsi:type="string">Color Filter</item>
        </argument>
    </arguments>
</virtualType>
<!-- Color Filter -->
```

#### BOOLEAN ATTRIBUTE
```xml
<!-- Carry Over -->
<virtualType name="FiloBlu\EvaAttributes\CarryOver" type="FiloBlu\EvaAttributes\BaseBoolean" shared="false">
    <arguments>
        <argument name="entityTypeId" xsi:type="const">Magento\Catalog\Model\Product::ENTITY</argument>
        <argument name="attributeCode" xsi:type="string">carryover</argument>
        <argument name="data" xsi:type="array">
            <item name="label" xsi:type="string">Carry Over</item>
        </argument>
    </arguments>
</virtualType>
<!-- Carry Over -->
```

To override an attribute property you can simply pass it in data array. 

For example to add a scope in an attribute:
```xml
<!-- Composition -->
<virtualType name="FiloBlu\EvaAttributes\Composition" type="FiloBlu\EvaAttributes\BaseText" shared="false">
    <arguments>
        <argument name="entityTypeId" xsi:type="const">Magento\Catalog\Model\Product::ENTITY</argument>
        <argument name="attributeCode" xsi:type="string">composition</argument>
        <argument name="data" xsi:type="array">
            <item name="label" xsi:type="string">Composition</item>
            <item name="global" xsi:type="const">Magento\Eav\Model\Entity\Attribute\ScopedAttributeInterface::SCOPE_STORE</item>
        </argument>
    </arguments>
</virtualType>
<!-- Composition -->
```